#include "stm32f10x_conf.h"
#include "stm32f10x_rtc.h"


void rtc_init( void );



//----------------------------------------------------------
//  [֐]: rtc_init
//----------------------------------------------------------
void rtc_init( void )
{

    /* Enable the PWR clock */
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_PWR | RCC_APB1Periph_BKP, ENABLE);

	    /* Allow access to RTC */
	    PWR_BackupAccessCmd(ENABLE);

		/* Reset Backup Domain */
		BKP_DeInit();

	    /* Reset RTC Domain */
	//    RCC_BackupResetCmd(ENABLE);
	//    RCC_BackupResetCmd(DISABLE);

	    /* Enable the LSE OSC */
	    RCC_LSEConfig(RCC_LSE_ON);

	    /* Wait until LSE is ready */
	    while (RCC_GetFlagStatus(RCC_FLAG_LSERDY) == RESET);

	    /* Select the RTC Clock Source */		// 32.768kHz
	    RCC_RTCCLKConfig(RCC_RTCCLKSource_LSE);
	//    RCC_RTCCLKConfig(RCC_RTCCLKSource_HSE_Div128);

		/* Enable RTC Clock */
		RCC_RTCCLKCmd(ENABLE);

		/* Wait for RTC registers synchronization */
		RTC_WaitForSynchro();

		/* Wait until last write operation on RTC registers has finished */
		RTC_WaitForLastTask();

		/* Set RTC prescaler: set RTC period to 1sec */
		RTC_SetPrescaler(32767); /* RTC period = RTCCLK/RTC_PR = (32.768 KHz)/(32767+1) */

		/* Wait until last write operation on RTC registers has finished */
		RTC_WaitForLastTask();

#if 0
	    /* Set the time to 00h 00mn 00s AM */
	uint32_t Tmp_HH = 0x00, Tmp_MM = 0x00, Tmp_SS = 0x00;
	    Tmp_HH = 00;
	    Tmp_MM = 00;
	    Tmp_SS = 00;
	    RTC_SetCounter(Tmp_HH*3600 + Tmp_MM*60 + Tmp_SS);
#endif

		/* Wait until last write operation on RTC registers has finished */
		RTC_WaitForLastTask();

		/* Enable the RTC Second */
	//	RTC_ITConfig(RTC_IT_SEC, ENABLE);
		RTC_ITConfig(RTC_IT_ALR, ENABLE);

		/* Wait until last write operation on RTC registers has finished */
		RTC_WaitForLastTask();


		BKP_WriteBackupRegister(BKP_DR1, 0xA5A5);

		/* Lock access to BKP Domain */
	//	PWR_BackupAccessCmd(DISABLE);


}


