
#include "stm32f10x_conf.h"
#include <stdio.h>


void USART_Configuration( void );
void InitializeTimer( void );
void GPIO_init( void );
void ADC_init( void );
u16 get_ADC( void );
void tim2_slow( void );
void tim2_38( void );
void Delay(volatile unsigned long delay);
void init_RTC_int(void);
void Time_Display(uint32_t TimeVar);
void set_time(uint32_t hour, uint32_t min, uint32_t sec);


//-----------------------------------------------
void Delay(volatile unsigned long delay)
{ 
	while(delay) delay--;
}


//-----------------------------------------------
void USART_Configuration(void)
{
	GPIO_InitTypeDef GPIO_InitStruct;
	USART_InitTypeDef USART_InitStruct;
	USART_ClockInitTypeDef USART_ClockInitStruct;

	/* oXNbNݒ */
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO | RCC_APB2Periph_GPIOA | RCC_APB2Periph_USART1, ENABLE);

	/* GPIOݒ */
	GPIO_StructInit(&GPIO_InitStruct);
	GPIO_InitStruct.GPIO_Pin   = GPIO_Pin_9;
	GPIO_InitStruct.GPIO_Mode  = GPIO_Mode_AF_PP;
	GPIO_InitStruct.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOA, &GPIO_InitStruct);

	GPIO_InitStruct.GPIO_Pin  = GPIO_Pin_10;
	GPIO_InitStruct.GPIO_Mode = GPIO_Mode_IN_FLOATING;
	GPIO_Init(GPIOA, &GPIO_InitStruct);

	/* USARTݒ */
	USART_ClockStructInit(&USART_ClockInitStruct);
	USART_ClockInitStruct.USART_Clock = USART_Clock_Enable;
	USART_ClockInit(USART1, &USART_ClockInitStruct);

	USART_DeInit(USART1);
	USART_StructInit(&USART_InitStruct);
	USART_InitStruct.USART_BaudRate            = 9600;
	USART_InitStruct.USART_WordLength          = USART_WordLength_8b;
	USART_InitStruct.USART_Parity              = USART_Parity_No;
	USART_InitStruct.USART_StopBits            = USART_StopBits_1;
	USART_InitStruct.USART_Mode                = USART_Mode_Tx | USART_Mode_Rx;
	USART_InitStruct.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
	USART_Init(USART1, &USART_InitStruct);

	USART_Cmd(USART1, ENABLE);
}


//-----------------------------------------------
void InitializeTimer( void )
{
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOD | RCC_APB2Periph_AFIO,  ENABLE);
	GPIO_InitTypeDef GPIO_InitStruct;
	GPIO_StructInit(&GPIO_InitStruct);
	GPIO_InitStruct.GPIO_Pin   = GPIO_Pin_12;
	GPIO_InitStruct.GPIO_Mode  = GPIO_Mode_AF_PP;
//	GPIO_InitStruct.GPIO_Mode  = GPIO_Mode_Out_PP;
	GPIO_InitStruct.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOD, &GPIO_InitStruct);




	// SYSCLK=72MHz
	// PCLK1=36MHz
	// TIM2CLK=72MHz
	// 1/72MHz x 7 = 97.2nsec
	// 97.2usec x 270 = 26.25usec (=1/38kHz)
	// 97.2usec x 90  = 8.75usec (on)
	// 97.2usec x 180 = 17.5usec (off)
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM4, ENABLE);

	TIM_TimeBaseInitTypeDef timerInitStructure; 
	timerInitStructure.TIM_Prescaler			= 7;
	timerInitStructure.TIM_CounterMode			= TIM_CounterMode_Up;
	timerInitStructure.TIM_Period				= 236;			// 37.96kHzeX^l
	timerInitStructure.TIM_ClockDivision		= TIM_CKD_DIV1;
	timerInitStructure.TIM_RepetitionCounter	= 0;
	TIM_TimeBaseInit(TIM4, &timerInitStructure);
	TIM_Cmd(TIM4, ENABLE);

// PWM1 Mode configuration: TIM4_CH1(PD12 CN3-19)   90 / 270 = 1/3 duty
	TIM_OCInitTypeDef  TIM_OCInitStructure;
	TIM_OCInitStructure.TIM_OCMode			= TIM_OCMode_PWM1;
	TIM_OCInitStructure.TIM_OutputState		= TIM_OutputState_Enable;
	TIM_OCInitStructure.TIM_Pulse			= 80;				// 1/3 ̓dl
	TIM_OCInitStructure.TIM_OCPolarity		= TIM_OCPolarity_High;
	TIM_OC1Init(TIM4, &TIM_OCInitStructure);
	TIM_OC1PreloadConfig(TIM4, TIM_OCPreload_Enable );
	TIM_ARRPreloadConfig(TIM4, ENABLE);

	//TM4_CH1=PD12 TM4_CH2=PD13 TM4_CH3=PD14 TM4_CH4=PD15
//	GPIO_PinRemapConfig(GPIO_Remap_TIM4, ENABLE);


//-------------------- TIM2
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2 , ENABLE);

	timerInitStructure.TIM_Prescaler			= 72;	// 1usec
	timerInitStructure.TIM_CounterMode			= TIM_CounterMode_Up;
	timerInitStructure.TIM_Period				= 0xFFFF;
	timerInitStructure.TIM_ClockDivision		= TIM_CKD_DIV1;
	timerInitStructure.TIM_RepetitionCounter	= 0;
	TIM_TimeBaseInit(TIM2, &timerInitStructure);
	TIM_Cmd(TIM2, ENABLE);

}


//-----------------------------------------------
void GPIO_init( void )
{

	GPIO_InitTypeDef GPIO_InitStruct;

	// GPIO D|[gLɂ܂
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOD, ENABLE);

	// PD.4|[go͂ɂ܂BPD.4=LED Lowœ_
	GPIO_InitStruct.GPIO_Pin		= _BV(4);
	GPIO_InitStruct.GPIO_Mode		= GPIO_Mode_Out_PP;
	GPIO_InitStruct.GPIO_Speed		= GPIO_Speed_50MHz;
	GPIO_Init(GPIOD, &GPIO_InitStruct);	// ֐ǂݏo܂B

// user switch
	RCC_APB2PeriphClockCmd( RCC_APB2Periph_GPIOA, ENABLE );
	GPIO_InitStruct.GPIO_Pin		= GPIO_Pin_0;
	GPIO_InitStruct.GPIO_Mode		= GPIO_Mode_IN_FLOATING;
	GPIO_Init(GPIOA, &GPIO_InitStruct);
}


//-----------------------------------------------
void ADC_init( void )
{

    GPIO_InitTypeDef	GPIO_InitStruct;
    ADC_InitTypeDef 	ADC_InitStruct;
 
	RCC_ADCCLKConfig( RCC_PCLK2_Div8 );
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_ADC2, ENABLE);

	ADC_DeInit(ADC2);


	GPIO_StructInit (&GPIO_InitStruct);
    GPIO_InitStruct.GPIO_Pin = GPIO_Pin_0;
    GPIO_InitStruct.GPIO_Mode = GPIO_Mode_AIN;
    GPIO_Init(GPIOC, &GPIO_InitStruct);
 
    /* ADC1 Configuration ------------------------------------------------------*/
    ADC_InitStruct.ADC_Mode                = ADC_Mode_Independent;
    ADC_InitStruct.ADC_ScanConvMode        = DISABLE;
    ADC_InitStruct.ADC_ContinuousConvMode  = DISABLE;
    ADC_InitStruct.ADC_ExternalTrigConv    = ADC_ExternalTrigConv_None;
    ADC_InitStruct.ADC_DataAlign           = ADC_DataAlign_Right;
    ADC_InitStruct.ADC_NbrOfChannel        = 1; 
    ADC_Init( ADC2, &ADC_InitStruct );

 
    /* Enable ADC2  */
    ADC_Cmd(ADC2, ENABLE);
 
    /* Enable ADC2 reset calibaration register */  
    ADC_ResetCalibration(ADC2);
 
    /* Check the end of ADC1 reset calibration register */
    while(ADC_GetResetCalibrationStatus(ADC2));
 
    /* Start ADC2 calibaration */
    ADC_StartCalibration(ADC2);
    /* Check the end of ADC2 calibration */
    while(ADC_GetCalibrationStatus(ADC2)); 
};


//-----------------------------------------------
u16 get_ADC(void)
{
    /* ADC2 regular channel10 configuration to sample time = 55.5 cycles */
    ADC_RegularChannelConfig( ADC2, ADC_Channel_10, 1, ADC_SampleTime_55Cycles5);

    // Start ADC2 Software Conversion
    ADC_SoftwareStartConvCmd( ADC2, ENABLE );
    // Wait until conversion completion

    while(ADC_GetFlagStatus(ADC2, ADC_FLAG_EOC) == RESET);
    // Get the conversion value
    return ADC_GetConversionValue(ADC2);
}


//-----------------------------------------------
void tim2_slow( void )
{
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2 , ENABLE);
	TIM_TimeBaseInitTypeDef timerInitStructure; 
//	timerInitStructure.TIM_Prescaler			= 72;	// 1usec
//	timerInitStructure.TIM_Prescaler			= 7200;	// 100usec
	timerInitStructure.TIM_Prescaler			= 36000;// 500usec
	timerInitStructure.TIM_CounterMode			= TIM_CounterMode_Up;
	timerInitStructure.TIM_Period				= 0xFFFF;
	timerInitStructure.TIM_ClockDivision		= TIM_CKD_DIV1;
	timerInitStructure.TIM_RepetitionCounter	= 0;
	TIM_TimeBaseInit(TIM2, &timerInitStructure);
	TIM_Cmd(TIM2, ENABLE);
}


//-----------------------------------------------
void tim2_38( void )
{
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2 , ENABLE);
	TIM_TimeBaseInitTypeDef timerInitStructure; 
	timerInitStructure.TIM_Prescaler			= 72;	// 1usec
	timerInitStructure.TIM_CounterMode			= TIM_CounterMode_Up;
	timerInitStructure.TIM_Period				= 0xFFFF;
	timerInitStructure.TIM_ClockDivision		= TIM_CKD_DIV1;
	timerInitStructure.TIM_RepetitionCounter	= 0;
	TIM_TimeBaseInit(TIM2, &timerInitStructure);
	TIM_Cmd(TIM2, ENABLE);
}


//-----------------------------------------------
void init_RTC_int(void)
{
	NVIC_InitTypeDef NVIC_InitStructure;

	/* Configure one bit for preemption priority */
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_1);

	/* Set the Vector Table base address at 0x08003000    for Dfu  */
	NVIC_SetVectorTable(NVIC_VectTab_FLASH, 0x3000); 

	/* Enable the RTC Interrupt */
	NVIC_InitStructure.NVIC_IRQChannel = RTC_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure);
}


//-----------------------------------------------
void RTC_IRQHandler(void)
{
//	if (RTC_GetITStatus(RTC_IT_SEC) != RESET)	//b荞݃tOȂȉ
//	{
//		RTC_ClearITPendingBit(RTC_IT_SEC);		//b荞݃tONA
//	}

	if (RTC_GetITStatus(RTC_IT_ALR) != RESET)
	{

	    /* Clear EXTI line17 pending bit */
	    EXTI_ClearITPendingBit(EXTI_Line17);

		/* Check if the Wake-Up flag is set */
		if (PWR_GetFlagStatus(PWR_FLAG_WU) != RESET)
		{
			/* Clear Wake Up flag */
			PWR_ClearFlag(PWR_FLAG_WU);
		}
		
		/* Wait until last write operation on RTC registers has finished */
		RTC_WaitForLastTask();
		
		/* Clear RTC Alarm interrupt pending bit */
		RTC_ClearITPendingBit(RTC_IT_ALR);
		
		/* Wait until last write operation on RTC registers has finished */
		RTC_WaitForLastTask();

//		Time_Display(RTC_GetCounter());
	}
}


//-----------------------------------------------
void Time_Display(uint32_t TimeVar)
{
  uint32_t THH = 0, TMM = 0, TSS = 0;

  /* Compute  hours */
  THH = TimeVar / 3600;
  /* Compute minutes */
  TMM = (TimeVar % 3600) / 60;
  /* Compute seconds */
  TSS = (TimeVar % 3600) % 60;

  lprintf("Time: %02d:%02d:%02d\n", THH, TMM, TSS);
}


//-----------------------------------------------
void set_time(uint32_t hour, uint32_t min, uint32_t sec)
{
    RTC_SetCounter(hour*3600 + min*60 + sec);

	/* Wait until last write operation on RTC registers has finished */
	RTC_WaitForLastTask();
}



#if 0
//-----------------------------------------------
/* 荞݂̐ݒs֐ */
void NVIC_Configuration(void)
{
  NVIC_InitTypeDef NVIC_InitStruct;

  /* USARTM荞ݐݒ */
  NVIC_InitStruct.NVIC_IRQChannel                   = USART1_IRQn;
  NVIC_InitStruct.NVIC_IRQChannelPreemptionPriority = 0;
  NVIC_InitStruct.NVIC_IRQChannelSubPriority        = 0;
  NVIC_InitStruct.NVIC_IRQChannelCmd                = ENABLE;
  NVIC_Init(&NVIC_InitStruct);

  USART_ClearITPendingBit(USART1, USART_IT_RXNE);
  USART_ITConfig(USART1, USART_IT_RXNE, ENABLE);
}
//-----------------------------------------------
/*
  USARTM 荞݃nh
  MGR[ĕԂ
*/
void USART1_IRQHandler(void)
{
  char data;

	if(USART_GetITStatus(USART1, USART_IT_RXNE) != RESET)
  {
    data = (char)USART_ReceiveData(USART1);
    if (data == '\r') {
      USART_SendString("\r\n");
    } else {
      USART_SendChar(data);
    }
  }
}
#endif



